<template>
  <div
    v-click-outside="onClickOutside"
    class="menu-dropdown"
  >
    <button
      ref="reference"
      class="menu-button"
      :class="{
        '--active': isActive,
        '--opened': toggle
      }"
      :data-qa="menuItem.code"
      @click="toggleToggle(!toggle)"
    >
      {{ menuItem.title }}
    </button>

    <transition name="fadeIn">
      <div
        v-if="toggle"
        class="menu-dropdown__list"
        :data-qa="dataQa"
        data-attr="ob-selector"
      >
        <div
          v-for="(entry, index) in members"
          :key="index"
          class="menu-dropdown__item"
          :data-qa="entry.code"
          @click.stop.prevent="!getChildren(entry.uuid) && go(entry)"
          @mouseenter="mouseenter"
          @mouseleave="mouseleave"
        >
          {{ entry.title }}
          <div
            v-if="getChildren(entry.uuid)"
            class="menu-dropdown__list menu-dropdown-level-3"
          >
            <div
              v-for="(entrySub, key) in getChildren(entry.uuid)"
              :key="key"
              class="menu-dropdown__item"
              :data-qa="entrySub.code"
              @click.stop.prevent="go(entrySub)"
            >
              {{ entrySub.title }}
            </div>
          </div>
        </div>
      </div>
    </transition>
  </div>
</template>

<script>
import ClickOutside from 'vue-click-outside'

export default {
  name: 'TopMenuDropdownMember',
  provide () {
    return {
      select: this
    }
  },
  directives: {
    ClickOutside
  },
  props: {
    role: {
      type: String,
      default: ''
    },
    menuItem: {
      type: Object,
      required: true
    },
    menu: {
      type: Array,
      default: () => []
    },
    isSingle: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      toggle: false
    }
  },
  computed: {
    members () {
      return this.menu.filter(item => item.parent_uuid === this.menuItem.uuid)
    },
    isActive () {
      return this.$route && this.$route.name && this.activeMenuItem && (this.children.find(i => i.uuid === this.activeMenuItem.parent_uuid || i.uuid === this.activeMenuItem.uuid) || this.menuItem.uuid === this.activeMenuItem.uuid) ? 1 : 0
    },
    children () {
      return this.members.length ? this.members : this.menu.filter(item => item.parent_uuid === this.menuItem.uuid)
    },
    activeMenuItem () {
      return this.menu.find(i => this.$route && i.code === this.$route.name)
    },
    routeName () {
      return this.$route && this.$route.name
    }
  },
  methods: {
    toggleToggle (flag) {
      if (this.isSingle) {
        this.$router && this.$router.push({ name: this.menuItem.code })
        this.$emit('change', this.menuItem)
      } else {
        this.toggle = flag
      }
    },
    go (member) {
      let route = this.menu.find(item => item.uuid === member.uuid)
      if (route && route.code !== this.routeName) {
        this.$router && this.$router.push({ name: route.code })
        this.$emit('change', member)
      }
      this.toggle = false
    },
    onClickOutside () {
      if (this.toggle) {
        this.toggle = false
      }
    },
    getChildren (uuid) {
      const result = this.menu.filter(item => item.parent_uuid === uuid)
      return result.length ? result : null
    },
    mouseenter (e) {
      const childElements = e.target.querySelectorAll('.menu-dropdown-level-3 .menu-dropdown__item')
      childElements.forEach(el => el.classList.add('opened'))
    },
    mouseleave (e) {
      const childElements = e.target.querySelectorAll('.menu-dropdown-level-3 .menu-dropdown__item.opened')
      childElements.forEach(el => el.classList.remove('opened'))
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "../../../static/css/mixins";
  .menu-dropdown {
    position: relative;
    cursor: pointer;
    display: inline-flex;
    flex-direction: row;
    height: 100%;
    color: $lavender;

    &__list {
      position: absolute;
      top: 100%;
      left: 0;
      z-index: 1;
      background: $Green-600;
      box-shadow: 0px 8px 20px rgba($color-text-base, 0.5);
      padding: 9px 0 9px 0;
    }
    &__item{
      position: relative;
      padding: 11px 20px 9px 20px;
      min-width: 182px;
      font-size: 12px;
      line-height: 16px;
      letter-spacing: 0.4px;
      color: $color-text-base;
      cursor: pointer;
      white-space: nowrap;

      .menu-dropdown-level-3 {
        opacity: 0;
        pointer-events: none;
        position: absolute;
        left: 100%;
        top: -9px;
        background: $Green-500;
        padding: 9px 0;
        transition: opacity .3s;
        .menu-dropdown__item{
          &:hover{
            background: $Green-400;
          }
        }
      }

      &:hover {
        background: $Green-500;
        .menu-dropdown-level-3 {
          background: $Green-500;
          box-shadow: 0px 8px 20px rgba(25, 30, 50, 0.5);
          opacity: 1;
          pointer-events: all;
          .menu-dropdown__item {
            &:hover {
              background: $Green-400;
            }
          }
        }
      }
    }
    .menu-button {
      height: 100%;
      padding: 0 10px;
      cursor: pointer;
      background: none;
      border: none;
      font-family: Roboto, sans-serif;
      font-style: normal;
      font-weight: normal;
      font-size: 16px;
      line-height: 20px;
      letter-spacing: 0.2px;
      outline: none;
      transition: opacity .2s;
      position: relative;
      z-index: 2;
      &.--active:before {
        content:'';
        position: absolute;
        height: 2px;
        left:0;
        right: 0;
        bottom: 0;
        background-color: $color-blue-smalt;
        color: white;
        opacity: 1 !important;
      }
      &.--opened{
        background: $Green-600;
      }
      &.--opened:before {
        content:'';
        position: absolute;
        height: 2px;
        left:0;
        display: none;
        right: 0;
        bottom: 0;
        background-color: $color-blue-smalt;
        color: white;
        opacity: 1 !important;
      }
      &:hover {
        color: $topMenuTextHover;
      }
    }
  }

  .fadeIn-enter, .fadeIn-leave-to {
    opacity: 0;
  }

  .fadeIn-enter-active, .fadeIn-leave-active {
    transition: all .2s ease-in-out;
  }
</style>
